/*******************************************************/
//    RVA   
// 
// IN  dwRva			- RVA
// IN  dwSectionRva		- RVA 
// IN  dwSectionCount	-  
// 
//  :
//      
/*******************************************************/
DWORD Rva2Offset(DWORD dwRva, PIMAGE_SECTION_HEADER dwSectionRva, USHORT dwSectionCount)
{
    for ( USHORT i=0; i<dwSectionCount; i++ ) {
		if ( dwRva >= dwSectionRva->VirtualAddress ) {
			if (dwRva < dwSectionRva->VirtualAddress + dwSectionRva->Misc.VirtualSize) {
                return (DWORD)(dwRva - dwSectionRva->VirtualAddress + dwSectionRva->PointerToRawData) ;
            }
        }
        dwSectionRva++;
    }
    return (DWORD)-1 ;
}

/*******************************************************/
//    ImageBase  EntryPoint 
// 
// IN  lpModuleName		-    
// OUT  dwImageBase		- ImageBase
// 
//  :
//  EntryPoint 
/*******************************************************/
DWORD GetModuleStartAddr(char *lpModuleName, DWORD *dwImageBase)
{
	DWORD dwStartAddr				= 0;
	IMAGE_DOS_HEADER *pDosHdr		= NULL;
	IMAGE_NT_HEADERS *pNtHdr		= NULL;
	HANDLE hFile = NULL, hMap		= NULL;
	
	hFile		= CreateFileA( lpModuleName, GENERIC_READ, FILE_SHARE_READ, 0, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, 0 );
	if( hFile == INVALID_HANDLE_VALUE ) return 0;
	hMap		= CreateFileMapping( hFile, 0, PAGE_READONLY, 0, 0, 0 );
	if( hMap == NULL ) return 0;
	
	pDosHdr		= (IMAGE_DOS_HEADER *)MapViewOfFile( hMap, FILE_MAP_READ, 0, 0, 0 );
	if(pDosHdr == NULL) return 0;
	pNtHdr		= (IMAGE_NT_HEADERS *)((DWORD)pDosHdr + pDosHdr->e_lfanew);
	dwStartAddr = (DWORD)pNtHdr->OptionalHeader.ImageBase + (DWORD)pNtHdr->OptionalHeader.AddressOfEntryPoint;
	if( dwImageBase != NULL ) *dwImageBase = (DWORD)pNtHdr->OptionalHeader.ImageBase;
	
	UnmapViewOfFile(pDosHdr);
	CloseHandle(hMap);
	CloseHandle(hFile);
	
	return dwStartAddr;
}

/*******************************************************/
//    
// 
// IN  hProcess		-    
// IN  lpCureFile	-        
// IN  lpFileName	-      
// IN  dwOEP		-  OEP
// IN  dwImageBase	-  ImageBase
// IN  dwStartAddr	-  EntryPoint
// 
//  :
//   0
/*******************************************************/
DWORD CureBinary(HANDLE hProcess, char *lpCureFile, char *lpFileName, DWORD dwOEP, DWORD dwImageBase, DWORD dwStartAddr)
{
	HANDLE hFile,hMapFile = NULL;
	LPVOID mFile = NULL;						//       
	DWORD dwImportVar = 0;						//       
	int i = 0;
	IMAGE_DOS_HEADER *pDosHdr		= NULL;
	IMAGE_NT_HEADERS *pNtHdr		= NULL;
	IMAGE_SECTION_HEADER *pSecHdr	= NULL;
	IMAGE_SECTION_HEADER *pItSecHdr	= NULL;
	IMAGE_OPTIONAL_HEADER *pOptHdr	= NULL;
	IMAGE_IMPORT_DESCRIPTOR *pItDes	= NULL;
	IMAGE_DATA_DIRECTORY *pDataHdr	= NULL;
	IMAGE_THUNK_DATA *pThunkData	= NULL;	
	IMAGE_IMPORT_BY_NAME *pItByName	= NULL;
	
	hFile		= CreateFile( lpCureFile, GENERIC_READ|GENERIC_WRITE, FILE_SHARE_READ|FILE_SHARE_WRITE,NULL, OPEN_EXISTING, FILE_ATTRIBUTE_NORMAL, NULL );
	hMapFile	= CreateFileMapping( hFile, NULL, PAGE_READWRITE, 0, 0, NULL );
	mFile		= MapViewOfFile( hMapFile, FILE_MAP_READ|FILE_MAP_WRITE, 0, 0, 0 );
		
	pDosHdr		= (IMAGE_DOS_HEADER *)mFile;
    pNtHdr		= (IMAGE_NT_HEADERS *)((DWORD)mFile + pDosHdr->e_lfanew);
	
	pOptHdr		= &pNtHdr->OptionalHeader;
	pDataHdr	= pOptHdr->DataDirectory;												//    IMAGE_DATA_DIRECTORY
	pSecHdr		= (IMAGE_SECTION_HEADER *)((DWORD)pOptHdr + sizeof(IMAGE_OPTIONAL_HEADER));

	dwSectionCount = pNtHdr->FileHeader.NumberOfSections;								//   

	pItSecHdr	= (IMAGE_SECTION_HEADER *)((DWORD)mFile + pDosHdr->e_lfanew + sizeof(IMAGE_NT_HEADERS));
	++pDataHdr;																			//        IMAGE_DATA_DIRECTORY   1     
	pItDes		= (IMAGE_IMPORT_DESCRIPTOR *)((DWORD)mFile + Rva2Offset(pDataHdr->VirtualAddress, pItSecHdr, dwSectionCount));
	//       ThunkValue                
	while(pItDes->Name != NULL) {
		if (pItDes->OriginalFirstThunk != 0) {
			pThunkData   = (IMAGE_THUNK_DATA *)((DWORD)mFile + Rva2Offset(pItDes->OriginalFirstThunk, pItSecHdr, dwSectionCount)) ;
		} else {
			pThunkData   = (IMAGE_THUNK_DATA *)((DWORD)mFile + Rva2Offset(pItDes->FirstThunk, pItSecHdr, dwSectionCount)) ;
		}
		while (pThunkData->u1.Ordinal != 0) {
			pItByName  = (IMAGE_IMPORT_BY_NAME *)((DWORD) mFile + Rva2Offset(pThunkData->u1.Function, pItSecHdr, dwSectionCount)) ;
			if (!(pThunkData->u1.Ordinal & IMAGE_ORDINAL_FLAG32)) {
				if((DWORD)(pThunkData->u1.AddressOfData + dwImageBase) > dwStartAddr) {
					if(i==0) ReadProcessMemory( hProcess, (LPCVOID)((DWORD)dwStartVar + FIRST_IMPORT), &dwImportVar, 4, NULL ); //    ThunkValue          ThunkValue
					else ReadProcessMemory( hProcess, (LPCVOID)((DWORD)dwStartVar + SECOND_IMPORT), &dwImportVar, 4, NULL ); //        ThunkValue
					printf("[+] ThunkValue fixed from 0x%.8X to 0x%.8X\n", pThunkData->u1.AddressOfData, dwImportVar & 0xFFFF);
					pThunkData->u1.AddressOfData = (DWORD)((dwImportVar-dwImageBase) - 2); //          -2.    =)
					i++;
				}
			}
			pThunkData++;
		}
		pItDes++;
	}

	i = 0;
	do { pSecHdr++; i++; } while(pNtHdr->FileHeader.NumberOfSections-1>i);
	
	//         (   )
	SetFilePointer(hFile, pSecHdr->PointerToRawData, 0, FILE_BEGIN);
	//     
	pSecHdr--;
	
	printf("[+] Number of sections decreased to %d\n", --pNtHdr->FileHeader.NumberOfSections);
	printf("[+] EntryPoint restored changed from 0x%.8X to 0x%.8X\n", pNtHdr->OptionalHeader.AddressOfEntryPoint, dwOEP);
	pNtHdr->OptionalHeader.AddressOfEntryPoint = dwOEP;													//   
	printf("[+] SizeOfImage fixed from 0x%.8X to 0x%.8X\n", pNtHdr->OptionalHeader.SizeOfImage, (DWORD)(pSecHdr->VirtualAddress + pSecHdr->Misc.VirtualSize));
	pNtHdr->OptionalHeader.SizeOfImage = (DWORD)(pSecHdr->VirtualAddress + pSecHdr->Misc.VirtualSize);	//   

	UnmapViewOfFile(mFile);
	CloseHandle(hMapFile);
	SetEndOfFile(hFile); //  
	CloseHandle(hFile); 

	return 0;
} 